;TIMER version 1.0 - batch file timer program
;By Darryl Seamans - August 11, 1991
;Batch file timer program
;References:
;Programmer's Guide to PC and PS/2 Video Systems.
;Microsoft Press.
;DOS Programmer's Reference.
;QUE Books.

DATA		SEGMENT

DIM EQU	1
;DIM equals the color value of the background
;against which the number will appear
BRIGHT EQU DIM+8
;BRIGHT equals the color the number will
;"light up" in
BEEPS EQU 1
;Number of times to beep when 00:00 is reached
;(For alarm routine)

TABLE	DW	N0,N1,N2,N3,N4,N5,N6,N7,N8,N9,BLANK
;Table of number locations
ERRMSG	DB	"Usage -",10,10,"     TIMER XXXX",13,10,13,10,"where XXXX "
	DB	"represents the time to count down from",13,10,"from "
	DB	"0000-9959 (0 min 0 sec - 99 min 59 sec)",13,10
	DB	13,10,"Written by Darryl Seamans",13,10,36
	DB	"Version 1.0 - 08/11/91"
CTR	DB	0,0,0,0
STARTX	DB	0
STARTY	DB	0
OLDDL	DB	0
ENDFLAG	DB	0
OFFX  	DB	0
OFFY  	DB	0
TICKS	DB	0
TO_WAIT_FOR	DB	18		
;Ticks to wait before decrementing timer
TIMES_WAITED	DB	0
;Seconds since last adjustement of
;TO_WAIT_FOR  --  keeps track of when
;we need to adjust TO_WAIT_FOR to 19
;to make up for lost .2 second when
;we wait for just 18 four times.


;These are the number patterns used
;by the program
;5x5 blocks, 0 represents the background
;and 1 represents where the number lights
;up.

N1	DB	0,0,1,0,0
	DB	0,1,1,0,0
	DB	0,0,1,0,0
	DB	0,0,1,0,0
	DB	0,1,1,1,0

N2	DB	1,1,1,1,0
	DB	0,0,0,0,1
	DB	0,1,1,1,0
	DB	1,0,0,0,0
	DB	1,1,1,1,1

N3	DB	1,1,1,1,0
	DB	0,0,0,0,1
	DB	0,1,1,1,0
	DB	0,0,0,0,1
	DB	1,1,1,1,0

N4	DB	0,0,0,1,0
	DB	0,0,1,1,0
	DB	0,1,0,1,0
	DB	1,1,1,1,1
	DB	0,0,0,1,0

N5	DB	1,1,1,1,1
	DB	1,0,0,0,0
	DB	1,1,1,1,0
	DB	0,0,0,0,1
	DB	1,1,1,1,0

N6	DB	0,1,1,1,1
	DB	1,0,0,0,0
	DB	1,1,1,1,0
	DB	1,0,0,0,1
	DB	0,1,1,1,0

N7	DB	1,1,1,1,1
	DB	0,0,0,0,1
	DB	0,0,0,1,0
	DB	0,0,1,0,0
	DB	0,0,1,0,0

N8	DB	0,1,1,1,0
	DB	1,0,0,0,1
	DB	0,1,1,1,0
	DB	1,0,0,0,1
	DB	0,1,1,1,0

N9	DB	0,1,1,1,0
	DB	1,0,0,0,1
	DB	0,1,1,1,1
	DB	0,0,0,0,1
	DB	1,1,1,1,0

N0	DB	0,1,1,1,0
	DB	1,0,0,0,1
	DB	1,0,0,0,1
	DB	1,0,0,0,1
	DB	0,1,1,1,0

BLANK	DB	0,0,0,0,0
	DB	0,0,0,0,0
	DB	0,0,0,0,0
	DB	0,0,0,0,0
	DB	0,0,0,0,0

DATA	ENDS

CODE		SEGMENT
	ORG	0h
	ASSUME	CS:CODE,DS:DATA,SS:STACK

MAIN	PROC	NEAR

	MOV	AX,DS
	MOV	ES,AX

	MOV	AX,DATA				;Make DATA segment addressable
	MOV	DS,AX
	MOV	SI,80h				;Now look at command line
	MOV	CH,BYTE PTR ES:[SI]		;Get count of chars after TM command
	CMP	CH,5				;Is it 5? (Space, plus 4 digits)
	JZ	SHORT OK_CONT			;Yes, so continue
	MOV	AH,9				;No, invalid time
	LEA	DX,ERRMSG			;Print error message
	INT	21h				;Do it
	JMP	SHORT TERMINATE2		;Terminate with error return code
OK_CONT:
	MOV	SI,82h				;Offset of time parameter
	MOV	CX,4				;Four numbers to process
	MOV	DI,OFFSET CTR			;Timer's data area
PARSE_CMDLINE:
	MOV	AH,BYTE PTR ES:[SI]		;Get character from command line
	CMP	AH,30H				;Is it '0'?
	JB	SHORT SETTO0			;No, below, so set it to 0
	CMP	AH,39H				;Is it '0'?
	JA	SHORT SETTO0			;No, above, so set it to 0
	JMP	SHORT CHAROK			;Was 0-9, so ok			
SETTO0:	MOV	AH,30h				;Assume it's save to use 0

CHAROK:	SUB	AH,'0'				;Make zero-based
	MOV	BYTE PTR DS:[DI],AH		;And put it in timer's CounTeR area
	INC	SI				;Bump pointer into command line
	INC	DI				;And pointer to timer's CounTeR area
	LOOP	SHORT PARSE_CMDLINE		;Process all 4 digits


	MOV	AH,2Ch				;Get time from DOS
	INT	21h
	MOV	BYTE PTR OLDDL,DL		;Save 100ths/second figure
RUN:
	CALL	DISP				;Display current countdown time
	CALL	SUBTRACT_SEC			;Decrement time
	CALL	PAUSE				;Wait for one second to go by
	CMP	BYTE PTR ENDFLAG,0FFh		;See if we've hit 00:00
	JZ	SHORT TERMINATE			;If so, sound alarm and exit
	MOV	AH,1				;Poll keyboard
	INT	16h
	JZ	SHORT RUN			;No key pressed
	MOV	AH,0				;If key pressed,
	INT	16h				;Read it
	CMP	AL,27				;Was it ESCape?
	JNZ	SHORT RUN			;No, so ignore and continue
TERMINATE:
	CALL	ALARM				;Sound alarm
	MOV	BYTE PTR [CTR],10		;Setting all CTR digits will cause display to blank out
	MOV	BYTE PTR [CTR+1],10
	MOV	BYTE PTR [CTR+2],10
	MOV	BYTE PTR [CTR+3],10
	CALL	DISP				;Display "blank out"
TERMINATE2:
						;TERMINATE2 would be jumped to
						;If command line form was not
						;valid by the command-line
						;parsing routine
	MOV	AX,4C00h			;And end
	INT	21h

MAIN	ENDP

ALARM	PROC	NEAR
	PUSH	AX
	PUSH	BX
	PUSH	CX				;This is called to sound an alarm
	MOV	CX,BEEPS				;Number of times to beep
ALARM_SOUND:
	MOV	AH,0Eh				;BIOS function 0EH=write char TTY
	MOV	AL,07				;Char 07 will cause beep
	MOV	BH,0				;Screen page 0
	INT	10h				;Do it
	LOOP	SHORT ALARM_SOUND			
	POP	CX
	POP	BX
	POP	AX
	RET					;Exit
ALARM	ENDP

PAUSE	PROC	NEAR

	PUSH	AX
	PUSH	DX
	PUSH	CX
	MOV	BYTE PTR TICKS,0		;Reset # of ticks gone by
WAIT:
	MOV	AH,2Ch				;Get DOS time
	INT	21h
	CMP	DL,OLDDL			;Have 100ths of seconds changed?
	JZ	SHORT WAIT			;No, so wait for it to change
	MOV	OLDDL,DL			;Yes, 1/18ths of sec. passed	
	INC	BYTE PTR TICKS
	MOV	AL,BYTE PTR TO_WAIT_FOR		;Increment count of them passed
	CMP	BYTE PTR TICKS,AL		;18 passed yet? (i.e., one sec.)
	JNZ	SHORT WAIT			;No, so wait still
	INC	BYTE PTR TIMES_WAITED		;# of seconds since last adjustment
	CMP	BYTE PTR TIMES_WAITED,4		;4 gone by?
	JNZ	SHORT NO_4			;Not 4 yet, skip adjustment
	MOV	BYTE PTR TO_WAIT_FOR,19		;Yes, make this next wait
						;One tick longer, to compensate
						;For extra time gained during
						;Last 4 seconds, since ticks
						;occur every 18.2 seconds, and
						;we can only wait for a whole
						;number of them.
						;Waiting 19 instead of 18 ticks
						;next time will make up for the
						;.2 seconds skipped by being
						;able to wait for only 18 the
						;previous 4 times. This will
						;make the timer much more acc-
						;urate and tick more or less in
						;time with DOS. 
	JMP	SHORT WAIT_OK			;19 ticks to wait set
NO_4:
	CMP	BYTE PTR TIMES_WAITED,5		;Have we just waited out 19 ticks?
	JNZ	SHORT WAIT_OK			;No
	MOV	BYTE PTR TIMES_WAITED,0		;Yes, so reset seconds since adjustment
	MOV	BYTE PTR TO_WAIT_FOR,18		;And set the delay for 18 like normal
						;When TIMES_WAITED = 4, it will
						;be time to correct by waiting
						;19 instead of 18 ticks to make
						;up for the .2 seconds fast we
						;will be.
WAIT_OK:
	POP	CX
	POP	DX
	POP	AX

	RET					;Otherwise return

PAUSE	ENDP
DISP_NUMBER	PROC	NEAR

	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX

	PUSH	SI
	PUSH	DI


	ADD	AL,AL				;Double AX so it will point to WORD
	MOV	SI,OFFSET TABLE			;Table of number images
	XOR	AH,AH				;Zero out hi-part of AX
	ADD	SI,AX				;And add it to SI which points to table of numbers

	MOV	BX,SI				;BX points to table of number images
	MOV	SI,WORD PTR [BX]		;SI will now contain offset of number itself

	MOV	STARTX,DL			;Where the UL corner of number will be
	MOV	STARTY,DH			;X and Y coordinates
	MOV	OFFX,0				;OFFX and OFFY keep track of where in
	MOV	OFFY,0				;The number on the screen we are

DRAW:
	MOV	AH,2				;BIOS function 2 = move cursor
	MOV	BH,0

	MOV	DL,STARTX			;Load DH,DL with coords to print number
	MOV	DH,STARTY
	ADD	DL,OFFX				;Then add in the location we are within
	ADD	DH,OFFY				;The number onscreen

	INT	10h				;Call BIOS to do it
	MOV	AH,09h				;BIOS function 09H prints char and attribute
	MOV	AL,BYTE PTR [SI]		;Load AL with byte from number pattern
	MOV	CX,1				;Printing only one character
	XOR	BH,BH				;Screen page 0
	MOV	BL,DIM				;And printing it in a dim color
	CMP	AL,1				;Unless byte from pattern is 1
	JNZ	SHORT NOT_ONE			;In which case
	MOV	BL,BRIGHT			;We make it bright so number will show up
						;against dark background
NOT_ONE:
	MOV	AL,176				;Char to print = kind of a crusty block

	INT	10h				;Call BIOS to print it
	INC	SI				;Bump pointer into number pattern

	INC	OFFX				;Move to next row
	CMP	OFFX,4				;Have we taken care of more than 4 or less rows?
	JLE	SHORT DRAW			;Yes, so just do next row
	MOV	OFFX,0				;No, all set on that row, so move to beginning
	INC	OFFY				;Of next column
	CMP	OFFY,4				;Unless we're at the end
	JLE	SHORT DRAW			;No, so continue
	MOV	OFFY,0				;Yes, so reset column pointer
						;Row pointer here will already be 0
	POP	DI
	POP	SI

	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RET					;And return

DISP_NUMBER	ENDP

SUBTRACT_SEC	PROC	NEAR			;This routine subtracts
						;One second from the time
						;And if the time = 00:00
						;It will set the flag to end
						;The program
	DEC	BYTE PTR [CTR+3]		;Are ones of seconds
	CMP	BYTE PTR [CTR+3],0		;Less than 0?
	JGE	SHORT TIME_OK
	MOV	BYTE PTR [CTR+3],9		;Yes, so set to 9		
	DEC	BYTE PTR [CTR+2]		;And decrement tens of seconds
	CMP	BYTE PTR [CTR+2],0		;If they're less than 0
	JGE	SHORT TIME_OK
	MOV	BYTE PTR [CTR+2],5		;Set to 5 for next minute
	DEC	BYTE PTR [CTR+1]		;And decrement ones of minutes
	CMP	BYTE PTR [CTR+1],0		;If that's 0
	JGE	SHORT TIME_OK
	MOV	BYTE PTR [CTR+1],9		;Set it to 9
	DEC	BYTE PTR [CTR]			;And decrement tens of minutes
	CMP	BYTE PTR [CTR],0		;If THAT's 0
	JGE	SHORT TIME_OK
						;Time has run out (=00:00)
	MOV	BYTE PTR ENDFLAG,0FFh		;Set flag to cause alarm and termination
	JMP	TERMINATE			;And terminate right away
TIME_OK:
	RET					;And return
SUBTRACT_SEC	ENDP

DISP	PROC	NEAR				;This proc displays the time left

	MOV	AL,BYTE PTR [CTR]		;Tens of minutes
	MOV	DL,20				;Load DH,DL with place to display it 
	MOV	DH,10
	CALL	DISP_NUMBER			;And display it. Same procedure
	MOV	AL,BYTE PTR [CTR+1]		;With rest of digits(except different locations)
	MOV	DL,26
	MOV	DH,10
	CALL	DISP_NUMBER
	MOV	AL,BYTE PTR [CTR+2]
	MOV	DL,34
	MOV	DH,10
	CALL	DISP_NUMBER
	MOV	AL,BYTE PTR [CTR+3]
	MOV	DL,40
	MOV	DH,10
	CALL	DISP_NUMBER
	RET
DISP	ENDP


CODE		ENDS


STACK	SEGMENT PARA STACK

	DW	80 DUP (0FFFFh)

STACK	ENDS

	END	MAIN
